import pathlib
from importlib import resources

from jinja2 import Environment, FileSystemLoader, select_autoescape

TEMPLATES_DIRNAME = "templates"


def create_template_env(project_root: pathlib.Path) -> Environment:
    user_template_path = project_root / TEMPLATES_DIRNAME
    builtin_template_path = resources.files("readthememo") / TEMPLATES_DIRNAME

    loader = FileSystemLoader([user_template_path, builtin_template_path])

    return Environment(
        loader=loader, autoescape=select_autoescape(), trim_blocks=True, keep_trailing_newline=True, lstrip_blocks=True
    )
